<?php
  /**
   * This page displays the form for adding a request,
   * and also handles the form.  WARNING: There is a WHOLE
   * LOT of javascript stuff that is written on the fly, so
   * that section of the code can be VERY confusing.
   * @author Jason Grafinger
   */

  session_start();

  require("./include/include.php");

  //Secure page...
  checkAuth();

  $conn = connect($master);

  //ONLY standard users can add requests
  if($_SESSION['userType'] == "std" && !isset($_GET['formsubmitted']))
  {
    //Display form

    //Form needs javascript!  Add to the $master array
    // It will be added to the topHTML

    //First, get the requestTypes that HAVE requestSubTypes
    $getRequestTypesQuery = "SELECT requestTypes.*,requestSubTypes.requestSubTypeID," .
      "requestSubTypes.requestSubTypeName FROM requestSubTypes " .
      "INNER JOIN requestTypes ON requestSubTypes.requestTypeID=" .
      "requestTypes.requestTypeID ORDER BY requestTypes.requestTypeID";
    $extraJavascript = "";
    $needExtraJavascript = false;

    $requestTypesResult = mysql_query($getRequestTypesQuery) OR
      die("Could not query the database. " . $getRequestTypesQuery);
    if(mysql_num_rows($requestTypesResult) > 0)
    {
      //Found need for javascript
      $needExtraJavascript = true;
      $subTypes = array();
      while($row = mysql_fetch_assoc($requestTypesResult))
      {
        $subTypes[$row['requestTypeID']][$row['requestSubTypeID']]
          = $row['requestSubTypeName'];
      }
    }

    //Set the javascript if needed
    if($needExtraJavascript)
    {
      $extraJavascript = "\n    <script language=\"javascript\">
      <!--
      function checkType(form)
      {
        /**
         * Checks if this new selection has any subTypes that must
         * be activated for selection.
         * @author Jason Grafinger
         */

        newValue = form.requestTypeID.options[form.requestTypeID.selectedIndex].value;
        switch(Number(newValue))
        {\n";

        foreach(array_keys($subTypes) as $requestTypeID)
        {
          $extraJavascript .= "          case {$requestTypeID}:
          {
            //Enable the drop-down, and fill the HTML
            var theSelect = document.myForm.requestSubTypeID;
            theSelect.disabled = false;\n";

          $options = "\\n            <option value=\\\"-1\\\">---Please Select---</option>\\n";
          foreach(array_keys($subTypes[$requestTypeID]) as $requestSubTypeID)
          {
            $options .= "            <option value=\\\"{$requestSubTypeID}\\\">" .
              $subTypes[$requestTypeID][$requestSubTypeID] . "</option>\\n";
          }

          $extraJavascript .= "            theSelect.innerHTML = \"{$options}\";
            break;
          }\n";
        }

        $extraJavascript .= "          default:
          {
            //No subtypes, disable the drop-down
            var theSelect = document.myForm.requestSubTypeID;
            theSelect.disabled = true;
            theSelect.innerHTML = \"\\n          <option value=\\\"-1\\\">---Please Select---</option>\\n\";
            break;
          }
        }
      }
      -->
    </script>\n";
    }
    $master['extraJavascript'] = $extraJavascript;

    ////////////
    // END OF THE JAVASCRIPT PART YAAAAY!
    ////////////

    $pgTitle = "Add request form";
    writeTop($pgTitle,false,$master,$_GET['error']);
    writeNav($_SESSION['userType']);

    $formHTML = "      <hr />
      <form name=\"myForm\" action=\"{$_SERVER['PHP_SELF']}?formsubmitted=t\" " .
      "method=\"post\">
        <p>
          <label>Request Type</label><br />
          <select name=\"requestTypeID\" onChange=\"checkType(this.form)\">
            <option value=\"-1\">---Please Select---</option>\n";

    $getRequestTypesQuery = "SELECT * FROM requestTypes";
    $requestTypesResult = mysql_query($getRequestTypesQuery) OR
      die("Could not query the database.");

    //Fill the options for requestTypes
    while($row = mysql_fetch_assoc($requestTypesResult))
    {
      $formHTML .= "            <option value=\"{$row['requestTypeID']}\">" .
        $row['requestTypeName'] . "</option>\n";
    }

    //URLDecode anything in the queryString
    foreach(array_keys($_GET) as $field)
    {
      $_GET[$field] = stripslashes(html_entity_decode(urldecode($_GET[$field])));
    }

    $formHTML .= "          </select>
        </p>
        <p>
          <label>Request Subtype</label><br />
          <select name=\"requestSubTypeID\" disabled=\"true\">
            <option value=\"-1\">---Please Select---</option>
          </select>
        </p>
        <p>
          <label>Deadline (yyyy-mm-dd format, <b>Optional</b>)</label><br />
          <input type=\"text\" name=\"deadline\" size=\"10\" value=\"{$_GET['deadline']}\" />
        </p>
        <p>
          <label>Requested Completion Date (yyyy-mm-dd format, <b>Optional</b>)</label><br />
          <input type=\"text\" name=\"requestedCompletionDate\" size=\"10\" value=\"{$_GET['requestedCompletionDate']}\" />
        </p>
        <p>
          <label>Url #1 (<b>Optional</b>)</label><br />
          <input type=\"text\" name=\"url1\" size=\"80\" value=\"{$_GET['url1']}\" />
        </p>
        <p>
          <label>Url #2 (<b>Optional</b>)</label><br />
          <input type=\"text\" name=\"url2\" size=\"80\" value=\"{$_GET['url2']}\" />
        </p>
        <p>
          <label>Url #3 (<b>Optional</b>)</label><br />
          <input type=\"text\" name=\"url3\" size=\"80\" value=\"{$_GET['url3']}\" />
        </p>
        <label>Notes</label><br />
        <textarea name=\"notes\" rows=\"10\" cols=\"80\">{$_GET['notes']}</textarea>
        <p>
          <input type=\"submit\" value=\"Submit\" />
        </p>
      </form>\n";

    echo $formHTML;
    writeBottom();
  }

  else if($_SESSION['userType'] == "std" && isset($_GET['formsubmitted']) &&
    $_GET['formsubmitted'] == "t")
  {
    //Handle form

    //Arrays to hold names of required fields/invalid values.
    // You can easily add/remove new requirements
    $requiredFields = array(
      0 => "requestTypeID");
    $invalidValues = array(
      "requestTypeID" => "-1",
      "requestSubTypeID" => "-1");
    $postedFields = array_keys($_POST);

    //Check to see that everything from $requiredFields is
    // set in $postedFields
    $validForm = true;
    foreach($requiredFields as $field)
    {
      if(!array_key_exists($field, $_POST))
      {
        //Required field not set!
        $validForm = false;
      }
    }

    $allValidValues = true;
    foreach(array_keys($invalidValues) as $field)
    {
      if(isset($_POST[$field]) &&
        $_POST[$field] == $invalidValues[$field])
      {
        //The field holds an invalid value
        $allValidValues = false;
      }
    }

    //Validate the deadline (if needed)
    $validDeadline = true;
    if(isset($_POST['deadline']) &&
      $_POST['deadline'] != "")
    {
      $deadlineArray = explode("-",$_POST['deadline']);
      if(sizeof($deadlineArray) == 3 &&
        is_numeric($deadlineArray[0]) &&
        is_numeric($deadlineArray[1]) &&
        is_numeric($deadlineArray[2]))
      {
        //Try to make a date out of the string
        $today = date("Y-m-d");
        $theDate = mktime(0,0,0,$deadlineArray[1],$deadlineArray[2],
          $deadlineArray[0]);
        if(!$theDate || strtotime($today) > $theDate)
        {
          //Invalid date
          $validDeadline = false;
        }
      }
      else
      {
        //Incorrect date format
        $validDeadline = false;
      }
    }

    //Validate the completionDate (if needed)
    $validCompletionDate = true;
    if(isset($_POST['completionDate']) &&
      $_POST['completionDate'] != "")
    {
      $completionDateArray = explode("-",$_POST['completionDate']);
      if(sizeof($completionDateArray) == 3 &&
        is_numeric($completionDateArray[0]) &&
        is_numeric($completionDateArray[1]) &&
        is_numeric($completionDateArray[2]))
      {
        //Try to make a date out of the string
        $today = date("Y-m-d");
        $theDate = mktime(0,0,0,$completionDateArray[1],
          $completionDateArray[2],
          $completionDateArray[0]);
        if(!$theDate || strtotime($today) > $theDate)
        {
          //Invalid date
          $validCompletionDate = false;
        }
      }
      else
      {
        //Incorrect date format
        $validCompletionDate = false;
      }
    }

    //Form validity based on both tests.
    $validForm = $validForm && $allValidValues &&
      $validDeadline && $validCompletionDate;

    if(!$validForm)
    {
      //Redirect
      $queryString = "?error=badAddReq&";
      foreach(array_keys($_POST) as $field)
      {
        $queryString .= $field . "=" . urlencode(htmlentities($_POST[$field])) . "&";
      }

      $redirectString = $_SERVER['PHP_SELF'] . $queryString;
      header("Location: " . $redirectString);
    }
    else
    {
      $postedItems = array();
      foreach(array_keys($_POST) as $field)
      {
        $field = mysql_real_escape_string($field);
        $value = mysql_real_escape_string($_POST[$field]);
        if($_POST[$field] != "")
        {
          //Use htmlentities() to change HTML special chars
          // (e.g. '&' becomes '&amp;')
          $_POST[$field] = htmlentities($_POST[$field]);

          //Add to the array of what actually was posted
          $postedItems[$field] = $_POST[$field];
        }
      }

      //Process the form
      $nonStrings = array("requestTypeID","requestSubTypeID");
      $queryFields = "userID,dateIssued";
      $queryValues = $_SESSION['userID'] . ",'" . date("Y-m-d") . "'";
      foreach(array_keys($postedItems) as $field)
      {
        $queryFields .= "," . $field;
        if(in_array($field,$nonStrings))
        {
          $queryValues .= "," . $postedItems[$field];
        }
        else
        {
          $queryValues .= ",'" . $postedItems[$field] . "'";
        }
      }

      //Construct the final query
      $query = sprintf("INSERT INTO requests (%s) VALUES (%s)",
        $queryFields,$queryValues);

//      echo "<p>{$query}</p>";

      //Try to execute the insert
      $result = mysql_query($query);

      $error = "";
      if(!result)
      {
        //ERROR
        $error = "?error=badInsert";
      }

      header("Location: " . $master['systemRoot'] . $error);
    }
  }

  else
  {
    //Bad page, redirect.
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }
?>