<?php
  /**
   * Page for display and handling of form that writes
   * the master configuration file.
   *
   * @author Jason Grafinger
   */

  $pageHTML = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"
    \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" >
  <head>
    <title>Cisrequest Setup</title>
    <style type=\"text/css\">
      body {
        background: #EEEEEE;
        }
      input {
        background: #DADADA;
        }
    </style>
  </head>
  <body>%s</body>
</html>";

  if(!isset($_GET['formsubmitted']))
  {
    //Display the form.

    $bodyHTML = "\n    <h1>Configuration Setup</h1><hr />
    <form action=\"createconfig.php?formsubmitted=t\" method=\"post\">
      <fieldset>
        <legend>System Information</legend>
        <label>System Name (i.e. &quot;SomeDepartment Request System&quot;)</label><br />
        <input type=\"text\" name=\"systemName\" size=\"80\" value=\"" .
          urldecode($_GET['systemName']) . "\" /><br />
        <label>System Root (i.e. In the <b>URL</b>, this is the part after the domain. &quot;/path/to/this/application/&quot;. Note: <b>Must</b> include trailing slash)</label><br />
        <input type=\"text\" name=\"systemRoot\" size=\"80\" value=\"" .
          urldecode($_GET['systemRoot']) . "\" /><br />
        <label>System Root URL (i.e. &quot;http://someurl.edu&quot;.  Note: Do <b>NOT</b> include the trailing slash)</label><br />
        <input type=\"text\" name=\"systemRootURL\" size=\"80\" value=\"" .
          urldecode($_GET['systemRootURL']) . "\" />
      </fieldset><br />
      <fieldset>
        <legend>Admin Information</legend>
        <label>Admin's Name</label><br />
        <input type=\"text\" name=\"admin\" size=\"80\" value=\"" .
          urldecode($_GET['admin']) . "\" /><br />
        <label>Admin's Email Address</label><br />
        <input type=\"text\" name=\"adminEmail\" size=\"80\" value=\"" .
          urldecode($_GET['adminEmail']) . "\" />
      </fieldset><br />
      <fieldset>
        <legend>Database Information (Note: MySQL <b>ONLY</b>)</legend>
        <label>Database Server Username</label><br />
        <input type=\"text\" name=\"dbUsername\" size=\"80\" value=\"" .
          urldecode($_GET['dbUsername']) . "\" /><br />
        <label>Database Server Password</label><br />
        <input type=\"text\" name=\"dbPassword\" size=\"80\" value=\"" .
          urldecode($_GET['dbPassword']) . "\" /><br />
        <label>Database Server Host (i.e. &quot;someserver.somecollege.edu:####&quot;.  Where &quot;####&quot; is the port number)</label><br />
        <input type=\"text\" name=\"dbHost\" size=\"80\" value=\"" .
          urldecode($_GET['dbHost']) . "\" /><br />
        <label>Database Name</label><br />
        <input type=\"text\" name=\"dbName\" size=\"80\" value=\"" .
          urldecode($_GET['dbName']) . "\" />
      </fieldset>
      <p>
        <input type=\"submit\" value=\"Initialize\" />
      </p>
    </form>\n  ";
  }
  else if(isset($_GET['formsubmitted']) && $_GET['formsubmitted'] == "t")
  {
    //Handle the form.

    //Need ALL these fields
    $neededFields = array("systemName","systemRoot","systemRootURL",
      "admin","adminEmail","dbUsername","dbPassword","dbHost","dbName");

    $allFieldsFilled = true;
    foreach($neededFields as $field)
    {
      if($_POST[$field] == "")
      {
        //Unfilled field!
        $allFieldsFilled = false;
      }
    }

    if(!$allFieldsFilled)
    {
      $redirectString = "?error=form";
      foreach($neededFields as $field)
      {
        $redirectString .= "&" . $field . "=" . urlencode($_POST[$field]);
      }

      //Redirect
      header("Location: " . $_SERVER['PHP_SELF'] . $redirectString);
    }

    else
    {
      //Good to go.  Create the config file
      $configFileName = "./include/config.php";
      $configFileText = "<?php
  /**
   * This configuration file sets a master array
   * of settings.
   * @author Jason Grafinger
   */

  \$master = array();

  // ADMINISTRATIVE DATA
  \$master['systemName'] = \"%s\";
  \$master['admin'] = \"%s\";
  \$master['adminEmail'] = \"%s\";
  \$master['systemRoot'] = \"%s\";
  \$master['systemRootURL'] = \"%s\";
  \$master['dbUsername'] = \"%s\";
  \$master['dbPassword'] = \"%s\";
  \$master['dbHost'] = \"%s\";
  \$master['dbName'] = \"%s\";

  // FONTS
  \$master['fontStyles']['body'] = \"georgia,serif\";
  \$master['fontStyles']['h1'] = \"verdana,sans-serif\";
  \$master['fontStyles']['h2'] = \"verdana,sans-serif\";

  // ERROR MESSAGES
  \$master['error']['auth1']['header'] = \"Authentication Error\";
  \$master['error']['auth1']['body'] = \"You have attempted to log in with \" .
    \"an incorrect username/password combination.\";
  \$master['error']['auth2']['header'] = \"Authentication Error\";
  \$master['error']['auth2']['body'] = \"You cannot access secure pages \" . 
    \"directly.\";
  \$master['error']['badPage']['header'] = \"Page Error\";
  \$master['error']['badPage']['body'] = \"You have attempted to access a \" . 
    \"page illegally.\";
  \$master['error']['query']['header'] = \"Database Query Error\";
  \$master['error']['query']['body'] = \"An error has occurred while \" .
    \"attempting to query the database.\";
  \$master['error']['del1']['header'] = \"Delete Error\";
  \$master['error']['del1']['body'] = \"An error has occurred while \" .
    \"attempting to delete a request.\";
  \$master['error']['editForm']['header'] = \"Edit/Form Error\";
  \$master['error']['editForm']['body'] = \"Please be sure to fill fields \" .
    \"correctly in the requested format.\";
  \$master['error']['registerForm']['header'] = \"Registration Error\";
  \$master['error']['registerForm']['body'] = \"All fields must be filled \" .
    \"and the email address <b>MUST</b> be a &quot;udel.edu&quot; address.\";
  \$master['error']['req1']['header'] = \"Request Error\";
  \$master['error']['req1']['body'] = \"You do not have authorization to \" .
    \"view the request you have selected.\";
?>";

      //Now fill those values
      $configFileText = sprintf($configFileText,
        $_POST['systemName'],
        $_POST['admin'],
        $_POST['adminEmail'],
        $_POST['systemRoot'],
        $_POST['systemRootURL'],
        $_POST['dbUsername'],
        $_POST['dbPassword'],
        $_POST['dbHost'],
        $_POST['dbName']);

      $fileHandle = fopen($configFileName,"w");
      if(fwrite($fileHandle,$configFileText) &&
        dbInit($_POST['dbHost'],$_POST['dbUsername'],
          $_POST['dbPassword'],$_POST['dbName']))
      {
        $bodyHTML = "\n    <h1>Success!</h1><hr />
    <p>
      The configuration has completed.<br /><br /><b>Note to the
      administrator:</b> Please exit your browser and run the
      &quot;./install&quot; script from the command line (within
      the install directory for this application.
    </p>\n  ";
      }
      else
      {
        $bodyHTML = "\n    <h1>Failure!</h1><hr />
    <p>
      An error has occurred either during creation of the configuration
      settings or initializing the database.  Please re-load the configuration
      form (you may simply go back in your browser) and double check all of 
      your settings.
    </p>\n  ";
      }

      fclose($fileHandle);
    }
  }
  else
  {
    //Bad page, redirect
    header("Location: createconfig.php");
  }

  echo sprintf($pageHTML,$bodyHTML);



  /**
   * This function creates an array of SQL commands for database
   * initialization, and executes them.  NOTE: The order of the array
   * is significant!
   */
  function dbInit($host,$uname,$pass,$dbName)
  {
    //Create array of SQL commands
    $sqlCommands = array();
    array_push($sqlCommands,
      "DROP TABLE IF EXISTS `admin`");
    array_push($sqlCommands,
      "CREATE TABLE `admin` (" .
      "`adminID` int(11) NOT NULL auto_increment," .
      "`username` varchar(25) NOT NULL," .
      "`password` varchar(25) NOT NULL," .
      "PRIMARY KEY  (`adminID`))");
    array_push($sqlCommands,
      "INSERT INTO `admin` VALUES (1,'root','password')");
    array_push($sqlCommands,
      "DROP TABLE IF EXISTS `requestStatus`");
    array_push($sqlCommands,
      "CREATE TABLE `requestStatus` (" .
      "`requestStatusID` int(11) NOT NULL auto_increment," .
      "`requestStatusName` tinytext NOT NULL," .
      "`closed` tinyint(1) NOT NULL," .
      "PRIMARY KEY  (`requestStatusID`))");
    array_push($sqlCommands,
      "INSERT INTO `requestStatus` VALUES (1,'New Request',0)," .
      "(2,'Accepted',1),(3,'Rejected',1),(4,'Updated',0)," .
      "(5,'Requested additional information from user',0)");
    array_push($sqlCommands,
      "DROP TABLE IF EXISTS `requestSubTypes`");
    array_push($sqlCommands,
      "CREATE TABLE `requestSubTypes` (" .
      "`requestSubTypeID` int(11) NOT NULL auto_increment," .
      "`requestSubTypeName` tinytext NOT NULL," .
      "`requestTypeID` int(11) NOT NULL default '0'," .
      "PRIMARY KEY  (`requestSubTypeID`))");
    array_push($sqlCommands,
      "INSERT INTO `requestSubTypes` VALUES " .
      "(1,'MS in Computer Science',3)," .
      "(2,'PhD in Computer Science',3)," .
      "(3,'Other MS program',3)," .
      "(4,'Other PhD program',3)," .
      "(5,'Law School',3)," .
      "(6,'Other',3)");
    array_push($sqlCommands,
      "DROP TABLE IF EXISTS `requestTypes`");
    array_push($sqlCommands,
      "CREATE TABLE `requestTypes` (" .
      "`requestTypeID` int(11) NOT NULL auto_increment," .
      "`requestTypeName` tinytext NOT NULL," .
      "PRIMARY KEY  (`requestTypeID`))");
    array_push($sqlCommands,
      "INSERT INTO `requestTypes` VALUES " .
      "(1,'Study Abroad')," .
      "(2,'Job Recommendation')," .
      "(3,'Graduate or Professional School')," .
      "(4,'Other')");
    array_push($sqlCommands,
      "DROP TABLE IF EXISTS `requests`");
    array_push($sqlCommands,
      "CREATE TABLE `requests` (" .
      "`requestID` int(11) NOT NULL auto_increment," .
      "`userID` int(11) NOT NULL default '0'," .
      "`dateIssued` date NOT NULL default '0000-00-00'," .
      "`notes` text," .
      "`requestTypeID` int(11) NOT NULL default '0'," .
      "`requestSubTypeID` int(11) default NULL," .
      "`deadline` date default NULL," .
      "`requestedCompletionDate` date default NULL," .
      "`url1` tinytext," .
      "`url2` tinytext," .
      "`url3` tinytext," .
      "`requestStatusID` int(11) NOT NULL default '1'," .
      "PRIMARY KEY  (`requestID`))");
    array_push($sqlCommands,
      "DROP TABLE IF EXISTS `users`");
    array_push($sqlCommands,
      "CREATE TABLE `users` (" .
      "`userID` int(11) NOT NULL auto_increment," .
      "`firstName` varchar(35) NOT NULL default ''," .
      "`lastName` varchar(35) NOT NULL default ''," .
      "`email` varchar(50) NOT NULL default ''," .
      "`password` varchar(8) NOT NULL default ''," .
      "`authString` varchar(64) NOT NULL default ''," .
      "PRIMARY KEY  (`userID`))");

    //connect to the database
    $returnVal = false;
    $conn = mysql_connect($host,$uname,$pass);
    if($conn)
    {
      $select = mysql_select_db($dbName,$conn) OR die(mysql_error());
      if($select)
      {
        $returnVal = true;
      }
    }

    if($returnVal)
    {
      //Now execute each command    
      foreach($sqlCommands as $cmd)
      {
        $returnVal = $returnVal && mysql_query($cmd);
      }
    }

    //Returns true if everything worked okay.  False otherwise
    return $returnVal;
  }
?>