<?php
  /**
   * Display a quick YES/NO option to the user, then
   * delete.
   * @author Jason Grafinger
   */

  function okayToDeleteReq($reqID,$userID)
  {
    /**
     * Returns whether or not this user can delete the req.
     * @return boolean Truth of permission to delete.
     */

    if(is_numeric($userID) && is_numeric($reqID))
    {
      //Check to see if the user has permission
      $query = "SELECT * FROM requests WHERE userID={$userID} AND " .
        "requestID={$reqID}";

      $result = mysql_query($query);
      if($result && mysql_num_rows($result) == 1)
      {
        //User owns the req, and has permission
        return true;
      }
      else
      {
        //User does not have permission
        return false;
      }
    }
    else
    {
      //Illegal arguments
      return false;
    }
  }

  session_start();

  require("./include/include.php");

  //Secure page...
  checkAuth();

  $conn = connect($master);

  //User hasn't selected 'yes'
  if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    !isset($_GET['go']))
  {
    //Check to see if user has permission to delete
    $permissionToDelete = false;
    if($_SESSION['userType'] == "admin")
    {
      $permissionToDelete = true;
    }
    else
    {
      $permissionToDelete = okayToDeleteReq($_GET['requestID'],
        $_SESSION['userID']);
    }

    //If permission granted, ask if they really want to delete
    if($permissionToDelete)
    {
      //Req info
      $query = "SELECT requestTypes.requestTypeName FROM requests INNER " .
        "JOIN requestTypes ON requests.requestTypeID=requestTypes." .
        "requestTypeID WHERE requests.requestID=" . $_GET['requestID'];

      $result = mysql_query($query);
      if(!$result || mysql_num_rows($result) != 1)
      {
        //Bad result, or too many rows returned
        // Something goofed
        header("Location: " . $master['systemRoot'] . "?error=query");
      }

      //Result vars
      $row = mysql_fetch_assoc($result);
      $requestType = $row['requestTypeName'];

      //HTML info
      $pgTitle = "Really Delete?";
      $includeSystemName = false;
      writeTop($pgTitle,$includeSystemName,$master,$_GET['error']);
      writeNav($_SESSION['userType']);
      $pageHTML = "      <hr />
      <p>
        Do you really want to delete request ID: {$_GET['requestID']},
        a &quot;{$requestType}&quot; type request?
      </p>
      <p>
        <a href=\"deleterequest.php?requestID={$_GET['requestID']}&amp;go=t\">
          YES</a> |
        <a href=\"viewrequests.php?requestID={$_GET['requestID']}>
          NO</a>
      </p>\n";
      echo $pageHTML;
      writeBottom();
    }
    else
    {
      //No permission, redirect
      header("Location: " . $master['systemRoot'] . "?error=badPage");
    }
  }

  //Go ahead and delete the req
  else if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    isset($_GET['go']) && $_GET['go'] == "t")
  {
    //Check to see if user has permission to delete
    $permissionToDelete = false;
    if($_SESSION['userType'] == "admin")
    {
      $permissionToDelete = true;
    }
    else
    {
      $permissionToDelete = okayToDeleteReq($_GET['requestID'],
        $_SESSION['userID']);
    }

    //If permission granted, DELETE!
    if($permissionToDelete)
    {
      //Just for good measure...
      $reqID = mysql_real_escape_string($_GET['requestID']);

      $query = "DELETE FROM requests WHERE requestID=" . $reqID;
      $result = mysql_query($query);

      //Set an error code if delete failed
      $errorMsg = ($result) ? "" : "?error=del1";

      header("Location: " . $master['systemRoot'] . $errorMsg);
    }
    else
    {
      //No permission, redirect
      header("Location: " . $master['systemRoot'] . "?error=badPage");
    }
  }

  else
  {
    //Bad page, redirect.
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }
?>