<?php
  /**
   * Allows edits for Status..(admin only), URLs, and notes
   * @author Jason Grafinger
   */

  function okayToEditReq($reqID,$userID)
  {
    /**
     * Returns whether or not this user can edit the req.
     * @return boolean Truth of permission to edit.
     */

    //No non-integer inputs
    if(is_numeric($userID) && is_numeric($reqID))
    {
      //Check to see if the user has permission
      $query = "SELECT * FROM requests WHERE userID={$userID} AND " .
        "requestID={$reqID}";

      $result = mysql_query($query);
      if($result && mysql_num_rows($result) == 1)
      {
        //User owns the req, and has permission
        return true;
      }
      else
      {
        //User does not have permission
        return false;
      }
    }
    else
    {
      //Illegal arguments
      return false;
    }
  }

  session_start();

  require("./include/include.php");

  //Secure page...
  checkAuth();

  $conn = connect($master);

  //Array that holds editable fields
  // Used when handling the form
  $databaseFields = array("notes","url1","url2","url3",
    "deadline","requestedCompletionDate");
  if($_SESSION['userType'] == "admin")
  {
    //Admins get to edit the requestStatusID
    array_push($databaseFields,"requestStatusID");
  }

  //////
  // HTML Mgmt
  //////

  //User hasn't submitted the form
  if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    !isset($_GET['formsubmitted']))
  {
    //Check to see if user has permission to edit
    $permissionToEdit = false;
    if($_SESSION['userType'] == "admin")
    {
      $permissionToEdit = true;
    }
    else
    {
      $permissionToEdit = okayToEditReq($_GET['requestID'],
        $_SESSION['userID']);
    }

    if($permissionToEdit)
    {
      //Req info
      $query = "SELECT requests.*,users.firstName,users.lastName," .
        "requestTypes.requestTypeName,requestSubTypes.requestSubTypeName," .
        "requestStatus.requestStatusName,requestStatus.closed " .
        "FROM requests " .
        "INNER JOIN requestStatus ON requests.requestStatusID=" .
        "requestStatus.requestStatusID " .
        "INNER JOIN users ON requests.userID=users.userID " .
        "INNER JOIN requestTypes ON requests.requestTypeID=requestTypes." .
        "requestTypeID " .
        "LEFT OUTER JOIN requestSubTypes ON requests.requestSubTypeID=" .
        "requestSubTypes.requestSubTypeID " .
        "WHERE requests.requestID=" . $_GET['requestID'];

      $result = mysql_query($query);
      if(!$result || mysql_num_rows($result) != 1)
      {
        //Bad result, or too many rows returned
        // Something goofed
        header("Location: " . $master['systemRoot'] . "?error=query");
      }

      //Result vars
      $row = mysql_fetch_assoc($result);

      //The following variables equal either the database value
      // OR the value specified in the query-string, depending
      // on whether the query-string is set
      $decodedNotes = (isset($_GET['notes'])) ?
        html_entity_decode(urldecode($_GET['notes'])) :
        html_entity_decode($row['notes']);
      $decodedURL1 = (isset($_GET['url1'])) ?
        html_entity_decode($_GET['url1']) :
        html_entity_decode($row['url1']);
      $decodedURL2 = (isset($_GET['url2'])) ?
        html_entity_decode($_GET['url2']) :
        html_entity_decode($row['url2']);
      $decodedURL3 = (isset($_GET['url3'])) ?
        html_entity_decode($_GET['url3']) :
        html_entity_decode($row['url3']);

      //Page HTML stuff
      $pgTitle = "Edit Form for Request ID: " . $row['requestID'];
      $showSystemName = false;
      writeTop($pgTitle,$showSystemName,$master,$_GET['error']);
      writeNav($_SESSION['userType']);

      //Create the form
      $pageHTML = "      <hr />
        <fieldset>
          <legend>Uneditable Fields</legend>
          <p>
            <b>Name:</b> " . $row['firstName'] . " " . $row['lastName'] .
        "          </p>
          <p>\n";

      //Only admins can edit the status of a page directly
      // so, if user is a non-admin, Status is in the
      // un-editable fields
      if($_SESSION['userType'] != "admin")
      {
        $pageHTML .= "            <b>Status:</b> " .
          $row['requestStatusName'] . "
      </p>
      <p>\n";
      }

      $pageHTML .= "            <b>Request Type:</b> " .
        $row['requestTypeName'] . "\n" .
        "          </p>\n";

      if(isset($row['requestSubTypeName']) &&
        $row['requestSubTypeName'] != "")
      {
        $pageHTML .= "          <p>
            <b>Request Subtype:</b> {$row['requestSubTypeName']}
          </p>\n";
      }

      $pageHTML .= "        </fieldset>
        <fieldset>
          <legend>Editable Fields</legend>
          <form action=\"editrequest.php?requestID={$_GET['requestID']}&amp;formsubmitted=t\" method=\"post\">\n";


      //Admins can edit the status of a request
      if($_SESSION['userType'] == "admin")
      {
        $pageHTML .= "            <p>
              <label>Status</label><br />
              <select name=\"requestStatusID\">
                <option value=\"-1\">---Please Select---</option>\n";

        //Get the possible status IDs
        $statusQuery = "SELECT * FROM requestStatus";
        $statusResult = mysql_query($statusQuery);
        if(!$statusResult || mysql_num_rows($statusResult) < 1)
        {
          header("Location: " . $master['systemRoot'] . "?error=query");
        }
        while($statusRow = mysql_fetch_assoc($statusResult))
        {
          $selectedHTML = "";
          if($statusRow['requestStatusName'] == $row['requestStatusName'])
          {
            $selectedHTML = " selected=\"true\" ";
          }
          $pageHTML .= "                " .
            "<option {$selectedHTML}value=\"{$statusRow['requestStatusID']}\">{$statusRow['requestStatusName']}</option>\n";
        }

        //Finish off the select for ALL userTypes
        $pageHTML .= "              </select>
            </p>\n";
      }

      $pageHTML .= "            <p>
              <label>Deadline (yyyy-mm-dd format)</label><br />
              <input type=\"text\" name=\"deadline\" size=\"10\" value=\"{$row['deadline']}\" /><br />
              <label>Requested Completion Date (yyyy-mm-dd format)</label><br />
              <input type=\"text\" name=\"requestedCompletionDate\" size=\"10\" value=\"{$row['requestedCompletionDate']}\" />
            </p>
            <p>
              <label>URL #1</label><br />
              <input type=\"text\" size=\"70\"name=\"url1\" value=\"{$decodedURL1}\" /><br />
              <label>URL #2</label><br />
              <input type=\"text\" size=\"70\" name=\"url2\" value=\"{$decodedURL2}\" /><br />
              <label>URL #3</label><br />
              <input type=\"text\" size=\"70\" name=\"url3\" value=\"{$decodedURL3}\" /><br />
              <label>Notes</label><br />
              <textarea rows=\"10\" cols=\"70\" name=\"notes\">{$decodedNotes}</textarea>
            </p>
            <p>
              <input type=\"submit\" value=\"Submit Edit\" />
            </p>
          </form>
        </fieldset>
      ";


      //IMPORTANT:  Override all page HTML __if__ the user is a NON
      // admin && the request's status is closed.
      // This means that the request shouldnt be editable for standard
      // users.
      if($_SESSION['userType'] != "admin" &&
        $row['closed'])
      {
        //Override
        $pageHTML = "      <hr />
        <p>
          <b>This request is listed as CLOSED.  You may not edit it.</b>
        </p>
        <p>
          <a href=\"viewrequests.php?requestID={$_GET['requestID']}\">BACK</a>
        </p>\n";
      }

      echo $pageHTML;
      writeBottom();
    }
    else
    {
      //No permission, redirect
      header("Location: " . $master['systemRoot'] . "?error=badPage");
    }
  }



  //Handle the form
  else if(isset($_GET['requestID']) && is_numeric($_GET['requestID']) &&
    isset($_GET['formsubmitted']) && $_GET['formsubmitted'] == "t")
  {
    //Check to see if user has permission to edit
    $permissionToEdit = false;
    if($_SESSION['userType'] == "admin")
    {
      $permissionToEdit = true;
    }
    else
    {
      $permissionToEdit = okayToEditReq($_GET['requestID'],
        $_SESSION['userID']);
    }

    //If permission granted
    if($permissionToEdit)
    {
      //Status can only be edited by an admin, but we must
      // validate the input (can't be '-1')
      $validRequestStatus = true;
      if($_SESSION['userType'] == "admin" &&
        $_POST['requestStatusID'] == "-1")
      {
        $validRequestStatus = false;
      }

      //Validate the dates
      $validDeadline = true;
      if(isset($_POST['deadline']) &&
        $_POST['deadline'] != "")
      {
        $deadlineArray = explode("-",$_POST['deadline']);
        if(sizeof($deadlineArray) == 3 &&
          is_numeric($deadlineArray[0]) &&
          is_numeric($deadlineArray[1]) &&
          is_numeric($deadlineArray[2]))
        {
          //Try to make a date out of the string
          $theDate = mktime(0,0,0,$deadlineArray[1],$deadlineArray[2],
            $deadlineArray[0]);
          if(!$theDate)
          {
            //Invalid date
            $validDeadline = false;
          }
        }
        else
        {
          //Incorrect date format
          $validDeadline = false;
        }
      }

      $validCompletionDate = true;
      if(isset($_POST['requestedCompletionDate']) &&
        $_POST['requestedCompletionDate'] != "")
      {
        $completionDateArray = explode("-",$_POST['requestedCompletionDate']);
        if(sizeof($completionDateArray) == 3 &&
          is_numeric($completionDateArray[0]) &&
          is_numeric($completionDateArray[1]) &&
          is_numeric($completionDateArray[2]))
        {
          //Try to make a date out of the string
          $theDate = mktime(0,0,0,$completionDateArray[1],
            $completionDateArray[2],
            $completionDateArray[0]);
          if(!$theDate)
          {
            //Invalid date
            $validCompletionDate = false;
          }
        }
        else
        {
          //Incorrect date format
          $validCompletionDate = false;
        }
      }

      //Total form validity relies on individual tests
      $validForm = $validDeadline && $validCompletionDate &&
        validRequestStatus;

      if(!$validForm)
      {
        //Redirect string management
        $redirectString = $_SERVER['PHP_SELF'] . "?requestID=" .
          $_GET['requestID'] . "&error=editForm";
        foreach(array_keys($_POST) as $field)
        {
          if($field != "requestStatusID")
          {
            $redirectString .= "&" . $field . "=" .
              urlencode(htmlentities($_POST[$field]));
          }
        }
        //Redirect back
        header("Location: " . $redirectString);
      }
      else
      {
        $finalEdits = array();
        foreach($databaseFields as $field)
        {
          $finalEdits[$field] = mysql_real_escape_string(htmlentities($_POST[$field]));
        }

        $wroteOnce = false;
        $updateQuery = "UPDATE requests SET ";

        foreach(array_keys($finalEdits) as $field)
        {
          if($wroteOnce)
          {
            $updateQuery .= ", ";
          }
          $updateQuery .= $field . "=";
          if($field != "requestStatusID")
          {
            $updateQuery .= "'";
          }
          $updateQuery .= $finalEdits[$field];
          if($field != "requestStatusID")
          {
            $updateQuery .= "'";
          }

          $wroteOnce = true;
        }

        //Non-Admins must mark the request as "updated"
        if($_SESSION['userType'] != "admin")
        {
          $updateQuery .= ",requestStatusID=4";
        }

        $updateQuery .= " WHERE requestID={$_GET['requestID']}";

        $result = mysql_query($updateQuery);
        if(!$result)
        {
          //Query error, redirect
          header("Location: " . $master['systemRoot'] . "?error=query");
        }
        else
        {
          //Success!  Redirect to view the updated request
          header("Location: " . $master['systemRoot'] . "viewrequests.php" .
            "?requestID=" . $_GET['requestID']);
        }
      }
    }

    else
    {
      //No permission, redirect
      header("Location: " . $master['systemRoot'] . "?error=badPage");
    }
  }

  else
  {
    //Bad page, redirect.
    header("Location: " . $master['systemRoot'] . "?error=badPage");
  }
?>